/* eslint-disable react-hooks/exhaustive-deps */
import React, {
  useState,
  useEffect,
} from 'react';
import '../App.css';
import axios from 'axios';
function FruitList (props) {
  const { fruitListData } = props;
  return (
    <table border="1" width="200px">
      <thead>
        <tr>
          <th>名字</th>
          <th>数量</th>
          <th>价格</th>
        </tr>
      </thead>
      <tfoot></tfoot>
      <tbody>
        {
          fruitListData.map((item, index) => {
            return (
              <tr key={index}>
                <td key={item.name}>{item.name}</td>
                <td key={item.num}>{item.num}</td>
                <td key={item.pice}>{item.pice}</td>
              </tr>
            )
          })
        }
      </tbody>
    </table>
  )
}

// 自定义请求 Hook
const useFetchData = (dependencies) => {
  let options = {
    url: 'https://www.fastmock.site/mock/56123bfe451fc35ede8511d9cad416ad/reacthook/getlist',
    method: 'get'
  }
  const [isLoading, setIsLoading] = useState(false);
  const [response, setResponse] = useState(null);
  const [param, setParams] = useState(dependencies);

  useEffect(() => {
    const fetchData = async (value) => {
      console.log(value)
      setIsLoading(true)
      try {
        const res = await axios({
          method:options.method,
          url:options.url+`/${value}`
        })
        setIsLoading(false)
        setResponse(res.data)
      } catch (err) {
        setIsLoading(false)
        console.log(err)
      }
    }
    fetchData(param)
  }, [param])

  return [isLoading, response, setParams];
}


function AsyncHook () {
  let options = {
    url: 'https://www.fastmock.site/mock/56123bfe451fc35ede8511d9cad416ad/reacthook/getlist',
    method: 'get'
  }

  // const [fruitListData, setfruitListData]
  const [searchValue, setSearchValue] = useState('')
  const [queryValue, setQueryValue] = useState('')
  const [asyncStr, setAsyncStr] = useState('')

  const [isLoading, response, setParams] = useFetchData(queryValue)

  // 更新输入框值
  const _inputChange = (e) => {
    setSearchValue(e.target.value)
  }

  useEffect(()=>{
    setParams(queryValue);
    setAsyncStr(options.url+`/${queryValue}`)
  },[queryValue])
  //实时查询  
  useEffect(()=>{
    setParams(searchValue);
    setAsyncStr(options.url+`/${searchValue}`)
  },[searchValue])

  // 搜索按钮点击的时候


  // 点击查询
  const _searchClick = () => {
    setQueryValue(searchValue)
  }

  return (
    <div className="App">
      <h3>异步请求</h3>
      <div>
        <span>您输入并查询了 {searchValue}</span>
        <br />
        <input style={{ width: "150px" }} onChange={(e) => _inputChange(e)} placeholder="请输入价格" />
        <button onClick={_searchClick}>search</button>
      </div>
      {/* loding */}
      <div>
        {
          isLoading ? "loading" : null
        }
      </div>
      <div style={{ marginTop: "10px" }} className="fruit">
        <h3>水果信息列表</h3>
        {/* 自定义Hook */}
        <FruitList fruitListData={response && response.data || []} />
        {/* <FruitList fruitListData={fruitListData.data ? fruitListData.data : []} /> */}
      </div>
      <p>请求：{asyncStr}</p>
    </div>
  )
}
export default AsyncHook;