import React, { useState, useEffect } from 'react';
import '../App.css';


function Children (props) {
  return (
    <div>
      来自父组件传递的值为:{props.num}
    </div>
  );
}

function BaseHook () {
  const [num, myNumset] = useState(0);
  // 定义一个state
  const [userInfo, setdatas] = useState({
    name: '一',
    like: '二',
    friend: '三',
  });
  const colorList = [
    '#FFF',
    '#FF7F24',
    '#48D1CC',
    '#87CEFF',
    '#FFC1C1'
  ]
  const [color] = useState(colorList);

  // 添加
  const _add = () => {
    if(num >= colorList.length-1) return;
    myNumset(num+1);
  };
  // 删除
  const _del = () => {
    if(num <= 0) return;
    myNumset(num-1);
  };

  const updateData = () => {
    setdatas({...userInfo,name: '三',friend: '一'});
  };

  useEffect(() => {
    document.body.style.background = color[num];
  }, [color,num])


  return (
    <div className="App">
      <h3>BaseHook</h3>
      <div className="content">
        <div className="counter">
          <h3>Counter</h3>
          <div>
            <span>数字</span>
            <span>{num}</span>
          </div>
          <div style={{ marginTop: "10px" }}>
            <button className="button" onClick={_add}>add</button>
            <button className="button" onClick={_del}>del</button>
          </div>
          <div className="children">
            <Children num={num} />
          </div>
        </div>
        <div className="user" style={{ marginTop: '10px' }}>
          <h3>UpdateAll</h3>
          <div>
            <span>名字：</span>
            <span>{userInfo.name}</span>
          </div>
          <div>
            <span>爱好：</span>
            <span>{userInfo.like}</span>
          </div>
          <div style={{ marginBottom: "10px" }}>
            <span>搭档：</span>
            <span>{userInfo.friend}</span>
          </div>
          <button className="button" onClick={updateData}>updateData</button>
        </div>
      </div>
      <p id="alert"></p>
    </div>
  );
}
export default BaseHook;
