import React, { Component } from 'react';
import '../App.css';



class Children extends Component {
  render () {
    const { num } = this.props;
    return (
      <div>
        来自父组件传递的值为:{num}
      </div>
    )
  }
}



// 1.基本的 更新State的方法
// 2.基本的 生命周期
// 3.基本的 父子组件传参
class BaseReact extends Component {

  constructor (props) {
    super(props);
    this.state = {
      num: 0,
      user: {
        name: "谢霆锋",
        like: "Cook",
        friend: '张柏芝',
        num: 18
      },
      color: ["green", "yellow", "red", "black"],
    }
  }

  // 不利用 Hook 进行 State操作
  _add = () => {
    let { num } = this.state;
    this.setState({
      num: num + 1,
    })
  }

  _del = () => {
    let { num } = this.state;
    this.setState({
      num: num - 1,
    })
  }

  _updateData = () => {
    this.setState({
      user: {
        name: "陈冠希",
        like: "Camera",
        friend: "谢霆锋",
      }
    })
  }

  componentDidMount () {
    document.getElementById("alert").innerHTML = "触发了componentDidMount生命周期"
  }

  componentDidUpdate () {
    const { color, num } = this.state;
    document.body.style.background = color[num] // 改变颜色
    document.getElementById("alert").innerHTML = "触发了componentDidUpdate生命周期"
  }

  componentWillMount () {
    document.body.style.background = "white"
  }

  render () {
    const { num, user } = this.state;
    return (
      <div className="App">
        <h3>BaseReact</h3>
        <div className="content">
          <div className="counter">
            <h3>Counter</h3>
            <div>
              <span>数字</span>
              <span>{num}</span>
            </div>
            <div style={{ marginTop: "10px" }}>
              <button className="button" onClick={this._add}>add</button>
              <button className="button" onClick={this._del}>del</button>
            </div>
            <div className="children">
              <Children num={num} />
            </div>
          </div>
          <div className="user" style={{ marginTop: '10px' }}>
            <h3>UpdateAll</h3>
            <div>
              <span>名字：</span>
              <span>{user.name}</span>
            </div>
            <div>
              <span>爱好：</span>
              <span>{user.like}</span>
            </div>
            <div style={{ marginBottom: "10px" }}>
              <span>搭档：</span>
              <span>{user.friend}</span>
            </div>
            <button className="button" onClick={this._updateData}>updateData</button>
          </div>
        </div>
        <p id="alert"></p>
      </div>
    )
  }
}

export default BaseReact;
