/* useContext */
import React, { useReducer, useContext, useEffect } from 'react';
import ReactDOM from 'react-dom';

const initialState = 0;
const myContext = React.createContext();


function reducer (state, action) {
  switch (action.type) {
    case "reset":
      return { count: initialState };
    case "increment":
      return { count: state.count + 1 };
    case "decrement":
      return { count: state.count - 1 };
    default:
      return state;
  }
}


const ContextProvider = props => {
  const [state, dispatch] = useReducer(reducer, { count: 0 });
  return (
    <myContext.Provider value={{ state, dispatch }}>
      {props.children}
    </myContext.Provider>
  );
};
const Counter = () => {
  const { state, dispatch } = useContext(myContext);
  const [str, setstr];
  useEffect(() => {
    console.log("调用了 useContext 的组件总会在 context 值变化时重新渲染")
  })

  const reset = () => {

  }

  const add = () => {

  }

  const del = () => [

  ]

  return (
    <div>
      Counter Count:
      <button onClick={reset}>Reset</button>
      <button onClick={add}>+</button>
      <button onClick={del}>-</button>
    </div>
  );
}
const CounterView = () => {
  useEffect(() => {
    console.log("调用了 useContext 的组件总会在 context 值变化时重新渲染---CounterView")
  })
  return (
    <div>
      Counter Count -only view:
    </div>
  );
}

ReactDOM.render(
  <div className="App">
    <ContextProvider>
      <Counter />
    </ContextProvider>
  </div>,
  document.getElementById('root'));
